package {
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.Event;
	import flash.geom.Point;

	public class motion extends Sprite
	{
		private var threads:Array;
		private var numSegments:uint = 3;
		private var gravity:Number = 0.5;
		private var bounce:Number = -0.9;
		private var ball:Array = new Array();
		private var bally:bally_mc = new bally_mc();
		private var sitetitle:siteTitle = new siteTitle();
		
		public function motion()
		{
			init();
		}
		
		private function init():void
		{
			stage.align = StageAlign.TOP; //top center?
			stage.scaleMode = StageScaleMode.NO_SCALE;
			ball['x'] = 0;
			ball['y'] = 0;
			ball['vx'] = 10;
			ball['vy'] = 0;
			ball['radius'] = 10;
			threads = new Array();
				//a multidimensional array
				//holds an array of threadSegs for each string (instrument)
								
			sitetitle.name = 'sitetitle';
			this.addChild(sitetitle);
			sitetitle.x = sitetitle.y = 40;
			
			createThreads();
			
			bally.name = 'bally';
			this.addChild(bally);
			
			addEventListener(Event.ENTER_FRAME, onEnterFrame);
			
			//this.stage.addEventListener(Event.RESIZE, onWindowResize);
		}
		
		//HOW TO DRAW A SEGMENT
		// new Segment(line length, thickness, color)
		
		private function xf(q:Number) { //fraction of canvas x
			//pretends canvas is 900x600 in center top
			return (900*q);
		}
		private function yf(q:Number) { //fraction of canvas y
			//pretends canvas is 900x600 in center top
			return (600*q);
		}
		private var lt:uint = 1; //line thickness
		private var lc:Number = 0x444444; //line color
		private var lc2:Number = 0xff0000;
		private var lc3:Number = 0xaaaaaa;
		private var otop = 0; //offset of top hang
		private var otext = 0.05; //offset of text hang
		
		private function createThreads():void {
			var yfn:Number; var lcn:Number; var i:uint;
			
			//accordion
			threads['accordion'] = new Array();
			for(i=0; i<18; i++) {
				switch(i) {
					case 17: yfn=yf(0.46+otop); lcn=lc; break;
					case 0: yfn=yf(otext+0.05); lcn=lc3; break;
					default: yfn=yf(0.014); lcn=lc2; break;
				}
				var s:Segment = new Segment(yfn,lt,lcn);
				var st:pageLabel = new pageLabel(); //IN LIBRARY
				st.txtBox.text = 'accordion';
				switch(i) {
					case 0: //the label, at the bottom
						s.addChild(st); st.x+=yfn;
						st.rotation=-90;
						//s.maxFlex=15;
						break;	
					case 17: //at the very top - no setting maxFlex here
						var s1:accordionTop = new accordionTop();
						s.addChild(s1); s1.x+=yfn; s1.rotation=-90;
						break;
					case 1: //the accordion bottom, at next-to-bottom
						var s2:accordionBottom = new accordionBottom();
						s.addChild(s2); s2.x=0; s2.rotation=-90;
						//s.maxFlex=1; //max flex 1º
						break;
					default: //all the little slats
						var s3:accordionMiddle = new accordionMiddle();
						s.addChild(s3); s3.x+=(yfn/2); s3.rotation=-90;
						//s.maxFlex=1; //max flex 1º
						break;
				}
				addChild(s); //add to the display
				threads['accordion'].push(s); //a reference to the obj for later
				if(i==17) { s.x = xf(0.17); s.y=0; } // "hang" it at the top
				else s.x = s.y = -1000; //put it off the screen
			}
			
			//electric guitar
			threads['electric'] = new Array();
			for(i=0; i<3; i++) {
				switch(i) {
					case 2: yfn=yf(0.08+otop); lcn=lc; break;
					case 0: yfn=yf(otext); lcn=lc3; break;
					case 1: yfn=yf(0.81); lcn=lc2; break;
				}
				var t:Segment = new Segment(yfn,lt,lcn);
				var tt:pageLabel = new pageLabel();
				tt.txtBox.text = 'electric';
				switch(i) { //now let's add contents
					case 1: //the middle
						var t1:electricGuitar = new electricGuitar();
						t.addChild(t1); t1.x=0; t1.rotation=-90;
						break;
					case 0: //the text
						t.addChild(tt); tt.x+=yfn; tt.rotation=-90;
						break;
				}
				addChild(t);
				threads['electric'].push(t);
				if(i==2) { t.x = xf(0.39); t.y=0; }
				else t.x = t.y = -1000;
			}
			
			//bass guitar	
			threads['bass'] = new Array();
			for(i=0; i<3; i++) {
				switch(i) {
					case 2: yfn=yf(0.05+otop); lcn=lc; break;
					case 1: yfn=yf(0.86); lcn=lc2; break;
					case 0: yfn=yf(otext); lcn=lc3; break;
				}
				var bassS:Segment = new Segment(yfn,lt,lcn);
				switch(i) { //now let's add contents
					case 1: //the middle
						var bass1:bassGuitar = new bassGuitar();
						bassS.addChild(bass1); bass1.x=0; bass1.rotation=-90;
						//bass1.alpha = 0.3;
						break;
					case 0: //the text
						var bass2:pageLabel = new pageLabel();
						bass2.txtBox.text = 'bass';
						bassS.addChild(bass2); bass2.x+=yfn; bass2.rotation=-90;
						break;
				}
				addChild(bassS);
				threads['bass'].push(bassS);
				if(i==2) { bassS.x = xf(0.61); bassS.y=0; }
				else bassS.x = bassS.y = -1000;
			}
			
			//drum
			threads['drum'] = new Array();
			for(i=0; i<5; i++) {
				switch(i) {
					case 4: yfn=yf(0.32+otop); lcn=lc; break;
					case 3: yfn=yf(0.14); lcn=lc; break;
					case 2: yfn=yf(0.06); lcn=lc; break;
					case 1: yfn=yf(0.28); lcn=lc2; break;
					case 0: yfn=yf(otext); lcn=lc3; break;
				}
				var drumS:Segment = new Segment(yfn,lt,lcn);
				switch(i) { //now let's add contents
					case 4: //put one drumstick at the base of this
						break;
					case 3: //put another drumstick at the base of this
						var stick1:drumstick1 = new drumstick1();
						drumS.addChild(stick1); stick1.x=0; stick1.rotation=-90;
						break;
					case 2: //nothing here
						var stick2:drumstick2 = new drumstick2();
						drumS.addChild(stick2); stick2.x=0; stick2.rotation=-90;
						break;
					case 1: //drum
						var drum1:drum = new drum();
						drumS.addChild(drum1); drum1.x=0; drum1.rotation=-90;
						break;
					case 0: //the text
						var drum2:pageLabel = new pageLabel();
						drum2.txtBox.text = 'drum';
						drumS.addChild(drum2); drum2.x+=yfn; drum2.rotation=-90;
						break;
				}
				addChild(drumS);
				threads['drum'].push(drumS);
				if(i==4) { drumS.x = xf(0.83); drumS.y=0; }
				else drumS.x = drumS.y = -1000;
			}
			
			//microphone
			threads['microphone'] = new Array();
			for(i=0; i<3; i++) {
				switch(i) {
					case 2: yfn=yf(0.2+otop); lcn=0x222222; break;
					case 1: yfn=yf(0.2); lcn=lc2; break;
					case 0: yfn=yf(otext); lcn=lc3; break;
				}
				var micS:Segment = new Segment(yfn,lt,lcn);
				switch(i) { //now let's add contents
					case 1: //the middle
						var mic1:microphone = new microphone();
						micS.addChild(mic1); mic1.x=0; mic1.rotation=-90;
						break;
					case 0: //the text
						var mic2:pageLabel = new pageLabel();
						mic2.txtBox.text = 'mic';
						micS.addChild(mic2); mic2.x+=yfn; mic2.rotation=-90;
						break;
				}
				addChild(micS);
				threads['microphone'].push(micS);
				if(i==2) { micS.x = xf(0.49); micS.y=0; }
				else micS.x = micS.y = -1000;
			}
			
		}
		
		private function onEnterFrame(event:Event):void
		{
			moveBall(); //put the ball somewhere
			moveThreads('accordion');
			moveThreads('electric');
			moveThreads('microphone');
			moveThreads('bass');
			moveThreads('drum');
		}
		
		private function moveThreads(inst:String):void {
			//inst is the instrument whose string we are moving.
			//use the one that is the key in threads[]
			
			var target:Point = reach(threads[inst][0], (threads[inst][0].maxFlex&&threads[inst].length>1?threads[inst][1]:null), ball['x'], ball['y']);
				//0 is the tail end threadseg, which points to the gravity (ball) //\/\/\/\/
				//so here we are asking that threadseg to point to the ball x and y
				//BUT there might be a maxFlex, which describes the max angle change
				//from next upward threadseg (next higher number) ... therefore
				//in the second argument we are maybe passing the parent threadseg
				//what the second argument is doing:
				//if threadseg i has a maxFlex, and if it isn't the topmost threadseg,
				//then pass parent threadseg (so reach can calculate its angle),
				//else pass null
			
			for(var i:uint = 1; i < threads[inst].length; i++)
			{
				var threadSeg:Segment = threads[inst][i];
				target = reach(threads[inst][i], (threads[inst][i].maxFlex&&i+1<threads[inst].length?threads[inst][i+1]:null), target.x, target.y);
			}
			for(i = threads[inst].length - 1; i > 0; i--)
			{
				var threadSegA:Segment = threads[inst][i];
				var threadSegB:Segment = threads[inst][i - 1];
				position(threadSegB, threadSegA);
			}
						
			threadSeg = threads[inst][0];
			var dx:Number = threadSeg.getPin().x - ball['x'];
			var dy:Number = threadSeg.getPin().y - ball['y'];
			var dist:Number = Math.sqrt(dx * dx + dy * dy);
			if(dist < ball['radius'])
			{
				ball['vx'] += Math.random() * 2 - 1;
				ball['vy'] += 1;
			}
		}
		
		private function reach(threadSeg:Segment, threadSegPar:Segment, xpos:Number, ypos:Number):Point
		{
			//first, if we've been passed a parent threadseg,
			//it means the current threadseg has a maxFlex in it,
			//so we need to find out what the parent's angle is

			//what's the angle that it should be reaching for?
			var angleReach:Number = Math.atan2(ypos-threadSeg.y, xpos-threadSeg.x);
			
			var cD:Number = (1/360); //convert degrees to rotations
			
			if(threadSegPar) { //if we can only flex by a certain amount
				/* nonfunctioning code omitted for the time being */
			}
			threadSeg.rotation = angleReach * 180 / Math.PI;
			
			//the distance between threadSeg origin and threadSeg pin
			var w:Number = threadSeg.getPin().x - threadSeg.x;
			var h:Number = threadSeg.getPin().y - threadSeg.y;
			
			//the d
			var tx:Number = xpos - w;
			var ty:Number = ypos - h;
			return new Point(tx, ty);
		}
		
		private function position(threadSegA:Segment, threadSegB:Segment):void {
			threadSegA.x = threadSegB.getPin().x;
			threadSegA.y = threadSegB.getPin().y;
		} //fn position

		private function moveBall():void {
			ball['vy'] += gravity;
			ball['x'] += ball['vx'];
			ball['y'] += ball['vy'];
			bally.x = ball['x'];
			bally.y = ball['y'];
			var rightSide:Number = stage.stageWidth - ((stage.stageWidth-900)/2);
			var leftSide:Number = 0 - ((stage.stageWidth-900)/2);
			if(ball['x'] + ball['radius'] > rightSide) { //off right side
				ball['x'] = rightSide - ball['radius'];
				ball['vx'] *= bounce;
			}
			else if(ball['x'] - ball['radius'] < leftSide ) { //off left side
				ball['x'] = leftSide + ball['radius'];
				ball['vx'] *= bounce;
			}
			if(ball['y'] + ball['radius'] > stage.stageHeight) { //off bottom side
				ball['y'] = stage.stageHeight - ball['radius'];
				ball['vy'] *= bounce;
			}
			else if(ball['y'] - ball['radius'] < 0) { //off top side
				ball['y'] = ball['radius'];
				ball['vy'] *= bounce;
			}
		} //fn moveBall
		
	} // public class main
}//paackage
