package {
	import flash.display.*;
	import flash.utils.*;
	import flash.events.*;
	import flash.geom.Rectangle;
	import flash.media.*;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	
	public class mplayer extends Sprite {
		
		public var songUrl:String;
		public var songName:String;
		private var currVol:Number = .5;
		private var currPan:Number = 0;
		var trans:SoundTransform;
		var channel:SoundChannel = new SoundChannel();
		
		/*UI:
		volDn
		volUp
		songTitle
		closebtn
		movearrows*/
		
		public function mplayer(a:String, b:String) {
			songName = a;
			songUrl = b;
			init();
		}
		
		private function init():void {
			toggleCloseBtn(false); //hide the button
			this.closebtn.buttonMode = true;
			this.closebtn.addEventListener(MouseEvent.CLICK, handleClick);
			this.addEventListener(MouseEvent.MOUSE_OVER, handleThisMouseOver);
			this.addEventListener(MouseEvent.MOUSE_OUT, handleThisMouseOut);
			this.addEventListener(MouseEvent.MOUSE_DOWN, startDragThis);
			this.addEventListener(MouseEvent.MOUSE_UP, stopDragThis);
			this.volUp.addEventListener(MouseEvent.CLICK, onVolUp);
			this.volUp.buttonMode = true; this.volUp.gotoAndStop('_up');
			this.volDn.buttonMode = true; this.volDn.gotoAndStop('_up');
			this.volDn.addEventListener(MouseEvent.CLICK, onVolDown);
			//this.songTitle.text = songName;
			playSong();
		}
		
		private function handleThisMouseOver(e:MouseEvent):void {
			toggleCloseBtn(true);
		}
		private function handleThisMouseOut(e:MouseEvent):void {
			toggleCloseBtn(false);
		}
		private function handleClick(e:MouseEvent):void {
			var target:Object = e.target;
			if(target.name == 'closebtn') {
				this.parent.removeChild(this);
				SoundMixer.stopAll();
			}
		}
		private function toggleCloseBtn(should:Boolean):void {
			this.getChildByName('closebtn').alpha = (should?1:0);
			this.getChildByName('movearrows').alpha = (should?1:0);
		}
		private function startDragThis(e:MouseEvent):void {
			this.startDrag(false,new Rectangle(0,0,stage.stageWidth-this.width,stage.stageHeight-this.height));
		}
		private function stopDragThis(e:MouseEvent):void {
			this.stopDrag();
		}
		
		private function playSong():void {
			var slc:SoundLoaderContext = new SoundLoaderContext(3000);
		    var snd:Sound = new Sound();
			channel.addEventListener(Event.SOUND_COMPLETE, onSoundComplete);
			trans = new SoundTransform(currVol, currPan);
			channel.soundTransform = trans;
			snd.load(new URLRequest('./music/'+songUrl), slc);
			channel = snd.play();
			songTitle.text = songName;
		}
		private function onSoundComplete(e:Event):void {
			this.parent.removeChild(this); //close tiny window
		}
		
		private function onVolUp(e:MouseEvent):void{
		       currVol *= 1.5;
		       trans = new SoundTransform(currVol, currPan);
		       channel.soundTransform = trans;
		}

		private function onVolDown(e:MouseEvent):void{
		       currVol *= 0.75;
		       trans = new SoundTransform(currVol, currPan);
		       channel.soundTransform = trans;
		}
		
	} //close public class motion extends sprite
} //close package