package {
	import flash.display.*; //sprite stagealign stagescalemode displayobject
	import flash.events.*; //event and mouseevent
	import flash.geom.Point;
	import flash.utils.*; //timer class
	
	import flash.net.*;
	
	import src.TweenLite;
	
	import fl.motion.easing.*;
	import flash.media.SoundMixer;
	import fl.video.FLVPlayback;

	public class structure extends Sprite
	{
		private var btnHome:siteTitle = new siteTitle();
		
		//The following are just basic mc wrappers for the instruments
		//along with a fake hanging-string and a label. They act as buttons.
		//I'm using them in lieu of actual cg motion threads as in ../motion.
		//I am instantiating the variables here so they are persistently accessible.
		private var btnAccordion:structureAccordion = new structureAccordion();
		private var btnBass:structureBassGuitar = new structureBassGuitar();
		private var btnDrum:structureDrums = new structureDrums();
		private var btnGuitar:structureElectricGuitar = new structureElectricGuitar();
		private var btnMic:structureMicrophone = new structureMicrophone();
		
		private var lastBtn = 'btnHome'; //last clicked

		//music vars
		var xmlList:XML;
		var xmlLoader:URLLoader = new URLLoader();
		var xmlItemList:XMLList;
		
		public function structure()
		{
			init();
		}
		
		private function init():void
		{
			stage.align = StageAlign.TOP; //top center?
			stage.scaleMode = StageScaleMode.NO_SCALE;
								
			btnHome.name = 'btnHome';
			this.addChild(btnHome);
			btnHome.x = btnHome.y = 30;
			
			/*createThreads();*/
			createButtons();			
			
			addEventListener(Event.ENTER_FRAME, onEnterFrame);
			
		}
		
		//HOW TO DRAW A SEGMENT
		// new Segment(line length, thickness, color)
		
		private function xf(q:Number) { //fraction of canvas x
			//pretends canvas is 900x600 in center top
			return (900*q);
		}
		private function yf(q:Number) { //fraction of canvas y
			//pretends canvas is 900x600 in center top
			return (600*q);
		}
		/*private var lt:uint = 1; //line thickness
		private var lc:Number = 0x444444; //line color
		private var lc2:Number = 0xff0000;
		private var lc3:Number = 0xaaaaaa;*/
		private var otop = 0; //offset of top hang
		//private var otext = 0.05; //offset of text hang
		
		private function createButtons():void {
			//accordion
			btnAccordion.x = btnAccordion.defaultx = xf(0.17);
				btnAccordion.y = -700; btnAccordion.name = 'btnAccordion';
			btnGuitar.x = btnGuitar.defaultx = xf(0.39);
				btnGuitar.y = -700; btnGuitar.name = 'btnGuitar';
			btnBass.x = btnBass.defaultx = xf(0.61);
				btnBass.y = -700; btnBass.name = 'btnBass';
			btnDrum.x = btnDrum.defaultx = xf(0.83);
				btnDrum.y = -700; btnDrum.name = 'btnDrum';
			btnMic.x = btnMic.defaultx = xf(0.49);
				btnMic.y = -700; btnMic.name = 'btnMic';
			
			btnAccordion.addEventListener(MouseEvent.CLICK, handleButton);
			btnGuitar.addEventListener(MouseEvent.CLICK, handleButton);
			btnBass.addEventListener(MouseEvent.CLICK, handleButton);
			btnDrum.addEventListener(MouseEvent.CLICK, handleButton);
			btnMic.addEventListener(MouseEvent.CLICK, handleButton);
			
			addChild(btnAccordion);
			addChild(btnGuitar);
			addChild(btnBass);
			addChild(btnDrum);
			addChild(btnMic);
			
			//TweenLite.to(blueWipe, 0.3, {scaleX:14, scaleY:14});
			//TweenLite.to(t1a, 1, {x:50, ease:Elastic.easeOut});
			//TweenLite.to(this.getChildByName('t1b'), 0.5, {x:(stage.stageWidth+10), ease:Cubic.easeIn});
			
			sendDown();
		}
		
		/*private function createThreads():void {
		}*/
		
		private function onEnterFrame(event:Event):void
		{
			/*moveBall(); //put the ball somewhere
			moveThreads('accordion');
			moveThreads('electric');
			moveThreads('microphone');
			moveThreads('bass');
			moveThreads('drum');*/
		}
		
		private function handleButton(e:MouseEvent):void {
			var target:Object = e.target;
			if(lastBtn!=target.name) { //if we didn't just click to reload current page
				
				lastBtn = target.name;
				
				if(target.name == 'btnMic') { //send down everything weirdly
					lastBtn='btnMic';
					TweenLite.to(btnAccordion,	1.8, {y:600, ease:Elastic.easeOut}); //defaulty
					TweenLite.to(btnGuitar,		2.0, {y:50, ease:Elastic.easeOut});
					TweenLite.to(btnBass,		1.8, {y:200, ease:Elastic.easeOut});
					TweenLite.to(btnDrum,		1.7, {y:800, ease:Elastic.easeOut});
					TweenLite.to(btnMic,		1.6, {y:1000, ease:Elastic.easeOut});
					switchHomeButton(true);
					loadAbout(); //creating the about page
				} else {
					//remove canvases we may have created
					if(this.getChildByName('musicCanvas')) this.removeChild(this.getChildByName('musicCanvas'));
					if(this.getChildByName('videoCanvas')) { 
						SoundMixer.stopAll();
						this.removeChild(this.getChildByName('videoCanvas'));
					}
					if(this.getChildByName('aboutCanvas')) this.removeChild(this.getChildByName('aboutCanvas'));
					if(this.getChildByName('storeCanvas')) this.removeChild(this.getChildByName('storeCanvas'));
					if(this.getChildByName('contactCanvas')) this.removeChild(this.getChildByName('contactCanvas'));
					
					//send up everything
					TweenLite.to(btnAccordion,	0.5, {y:-700, ease:Cubic.easeIn});
					TweenLite.to(btnGuitar,		0.7, {y:-700, ease:Cubic.easeIn});
					TweenLite.to(btnBass,		0.5, {y:-700, ease:Cubic.easeIn});
					TweenLite.to(btnDrum,		0.4, {y:-700, ease:Cubic.easeIn});
					TweenLite.to(btnMic,		0.3, {y:-700, ease:Cubic.easeIn});
										
					var myTimer:Timer = new Timer(750,1);
					myTimer.addEventListener("timer", handleSendDown);
					myTimer.start();
					
				}				
			}
		}
		
		private function handleSendDown(e:Event):void {
			sendDown();
		}
		private function sendDown():void {
			if(lastBtn == 'btnHome') { //send down everything
				btnAccordion.x = btnAccordion.defaultx;
				btnGuitar.x = btnGuitar.defaultx;
				btnBass.x = btnBass.defaultx;
				btnDrum.x = btnDrum.defaultx;
				btnMic.x = btnMic.defaultx;
				TweenLite.to(btnAccordion,	1.5, {y:100, ease:Elastic.easeOut});
				TweenLite.to(btnGuitar,		1.7, {y:40, ease:Elastic.easeOut});
				TweenLite.to(btnBass,		1.5, {y:20, ease:Elastic.easeOut});
				TweenLite.to(btnDrum,		1.4, {y:60, ease:Elastic.easeOut});
				TweenLite.to(btnMic,		1.3, {y:80, ease:Elastic.easeOut});
				switchHomeButton(false);
			} else { //send down the one it shouldbe
				this.getChildByName(lastBtn).x = xf(0.17);
				TweenLite.to(this.getChildByName(lastBtn), 1.4, {y:60, ease:Elastic.easeOut});
				switchHomeButton(true);
				
				if(lastBtn=='btnGuitar') { //creating the music page
					loadMusic();
				}
				if(lastBtn=='btnAccordion') { //creating the news/video page
					loadVideo();
				}
				if(lastBtn=='btnBass') { //creating the store page
					loadStore();
				}
				if(lastBtn=='btnDrum') { //creating the contact page
					loadContact();
				}
			}	
		}
		
		private function loadMusic():void {
			//load music stuff
			var musicCanvas:MovieClip = new MovieClip();
			musicCanvas.x = 300; musicCanvas.y = 100;
			musicCanvas.name = 'musicCanvas';
			var q:paragraph = new paragraph();
			//q.y = 200;
			q.txtbox.text = 'Loading, please wait...'; q.name = 'statustxt';
			this.addChild(musicCanvas);
			musicCanvas.addChild(q);
			
			//xmlList, xmlLoader, xmlItemList
			xmlLoader.load(new URLRequest("music.xml"));
			xmlLoader.addEventListener(Event.COMPLETE, xmlMusicLoaded);
			xmlLoader.addEventListener(IOErrorEvent.IO_ERROR, xmlErrorHandler);
		}
		
		private function loadVideo():void {
			//first, if something's playing, cancel it out
			if(this.getChildByName('mplayer')) { //if something's already playing
				SoundMixer.stopAll(); //stop all sounds
				this.removeChild(getChildByName('mplayer'));
			}
			var videoCanvas:MovieClip = new MovieClip();
			videoCanvas.x = 300; videoCanvas.y = 100;
			videoCanvas.name = 'videoCanvas';
			this.addChild(videoCanvas);
			//build a list of play links
			var placey = 0; //this will be used to place things vertically
			var pa:headerlabel = new headerlabel(); pa.txtbox.text = 'placeholder video';
			pa.y = placey; videoCanvas.addChild(pa); placey += 40;
			var pb:FLVPlayback = new FLVPlayback(); pb.name = 'videoPlayer';
			pb.y = placey; videoCanvas.addChild(pb); placey += 20 + pb.height;
			pb.autoPlay = true;
			pb.skin = './src/SkinUnderPlaySeekMute.swf';
			pb.source = './video/video.flv';
		}
		private function loadAbout():void {
			var aboutCanvas:MovieClip = new MovieClip();
			aboutCanvas.x = 400; aboutCanvas.y = 100;
			aboutCanvas.name = 'aboutCanvas';
			this.addChild(aboutCanvas);
			var placey = 0; //this will be used to place things vertically
			var pa:headerlabel = new headerlabel(); pa.txtbox.text = 'about the band';
			pa.y = placey; aboutCanvas.addChild(pa); placey += 30;
			var pb:paragraph = new paragraph();
			pb.txtbox.text = "On this page, I'd like to extend the canvas downward and have a scroll bar appear, so that each band member can be introduced next to the instrument they play."
			pb.y = placey; aboutCanvas.addChild(pb);
		}
		private function loadStore():void {
			var storeCanvas:MovieClip = new MovieClip();
			storeCanvas.x = 300; storeCanvas.y = 100;
			storeCanvas.name = 'storeCanvas';
			this.addChild(storeCanvas);
			var placey = 0; //this will be used to place things vertically
			var pa:headerlabel = new headerlabel(); pa.txtbox.text = 'store';
			pa.y = placey; storeCanvas.addChild(pa); placey += 30;
			var pb:paragraph = new paragraph();
			pb.txtbox.text = "On this page, I'll integrate a Paypal checkout - or at any rate, I'll do a fancier job than this:";
			pb.y = placey; storeCanvas.addChild(pb); placey += 40;
			var pc:link = new link(); pc.txtbox.text = 'Buy our album!'; pc.url = 'http://wiseturtleband.com/purchase/';
			pc.y = placey; storeCanvas.addChild(pc); placey += 20;
			pc.addEventListener(MouseEvent.CLICK, function(){
					navigateToURL(new URLRequest(pc.url), '_blank');
				});
			pc.buttonMode = true; pc.mouseChildren = false;
		}
		private function loadContact():void {
			var contactCanvas:MovieClip = new MovieClip();
			contactCanvas.x = 300; contactCanvas.y = 100;
			contactCanvas.name = 'contactCanvas';
			this.addChild(contactCanvas);
			var placey = 0; //this will be used to place things vertically
			var pa:headerlabel = new headerlabel(); pa.txtbox.text = 'contact us';
			pa.y = placey; contactCanvas.addChild(pa); placey += 30;
			var pb:paragraph = new paragraph();
			pb.txtbox.text = "On this page, I'd like to have a submission form, or even better, a comment thread. In the meantime you can email us here:"
			pb.y = placey; contactCanvas.addChild(pb); placey += 50;
			var pc:link = new link(); pc.txtbox.text = 'theband@wiseturtleband.com';
			pc.y = placey; contactCanvas.addChild(pc);
			pc.buttonMode = false; pc.mouseChildren = false;
		}
		
		
		private function switchHomeButton(should:Boolean):void {
			//enable and disable home button
			btnHome.buttonMode = should;
			if(should) btnHome.addEventListener(MouseEvent.CLICK, handleButton);
			else btnHome.removeEventListener(MouseEvent.CLICK, handleButton);
			btnHome.gotoAndStop('_up');
		}
		
		//music stuff

		function xmlErrorHandler(event:IOErrorEvent):void{
			if(this.getChildByName('musicCanvas')) {
				var e:MovieClip = this.getChildByName('musicCanvas') as MovieClip;
				while(e.numChildren) e.removeChild(e.getChildAt(0));
				var q:paragraph = new paragraph();
				q.y = 200; q.txtbox.text = 'Sorry, XML loading error! '+event;
				(e as MovieClip).addChild(q);
			}
		}

		function xmlMusicLoaded(event:Event):void{
			xmlList = new XML(xmlLoader.data);
			xmlItemList = xmlList.song; //here we've built a list of songs
			var e:MovieClip = this.getChildByName('musicCanvas') as MovieClip;
			while(e.numChildren) e.removeChild(e.getChildAt(0));
			//build a list of play links
			var placey = 0; //this will be used to place things vertically
			var pa:headerlabel = new headerlabel(); pa.txtbox.text = 'sample tracks';
			pa.y = placey; e.addChild(pa); placey += 20;
			var pb:paragraph = new paragraph(); pb.txtbox.text = 'have a listen to our impressive sonic wares:';
			pb.y = placey; e.addChild(pb); placey += 30;
			for(var i:uint = 0; i<xmlItemList.length(); i++) {
				var pc:link = new link(); pc.txtbox.text = xmlItemList[i].attribute('title'); pc.url = xmlItemList[i].attribute('url');
				pc.y = placey; e.addChild(pc); placey += 20;
				pc.addEventListener(MouseEvent.CLICK, playSong);
				pc.buttonMode = true; pc.mouseChildren = false;
			}
			
		}
		
		function playSong(e:MouseEvent):void {
			if(this.getChildByName('mplayer')) { //if something's already playing
				SoundMixer.stopAll(); //stop all sounds
				this.removeChild(getChildByName('mplayer'));
			}
			var target:link = (e.target as link); //does this work?
			var mp:mplayer = new mplayer(target.txtbox.text,target.url);
			mp.x = 600; mp.y = target.y + 100; mp.name = 'mplayer';
			addChild(mp);
		}

		//as yet unimplemented preloader
		/*function progressHandler(e:ProgressEvent):void{
			homepage_bkg.visible = false;
			bar.visible = true;
			prog_txt. visible = true;
			var percent:int = loadWindow.percentLoaded;
			prog_txt.text = String(loadWindow.bytesLoaded) + " of " + String(loadWindow.bytesTotal) + " bytes" + "\n" + " (" + percent + "% loaded)";
			bar.setProgress(e.bytesLoaded, e.bytesTotal);
		}

		function completeHandler(event:Event):void{
			bar.visible = false;
			prog_txt.visible = false;
			loadWindow.visible = true;
			loadWindow.removeEventListener(ProgressEvent.PROGRESS, progressHandler);
			loadWindow.removeEventListener(Event.COMPLETE, completeHandler);
		}*/		
		
	} // public class main
}//paackage
